/*
 * Copyright (C) 2015 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.pixscape;

import org.thema.pixscape.tools.PointAttributeDialog;
import org.thema.pixscape.tools.OptionDialog;
import org.locationtech.jts.geom.Point;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.SplashScreen;
import java.awt.Toolkit;
import java.awt.color.ColorSpace;
import java.awt.event.ActionEvent;
import java.awt.image.BandedSampleModel;
import java.awt.image.ColorModel;
import java.awt.image.ComponentColorModel;
import java.awt.image.DataBuffer;
import java.awt.image.Raster;
import java.awt.image.RenderedImage;
import java.awt.image.WritableRaster;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.EventObject;
import java.util.List;
import java.util.Map;
import java.util.NavigableSet;
import java.util.TreeSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.media.jai.TiledImage;
import javax.swing.AbstractAction;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import org.apache.commons.math3.stat.descriptive.SummaryStatistics;
import org.geotools.coverage.grid.GridCoverage2D;
import org.geotools.coverage.grid.GridCoverageFactory;
import org.geotools.geometry.Envelope2D;
import org.thema.common.Config;
import org.thema.common.JavaLoader;
import org.thema.common.ProgressBar;
import org.thema.common.Util;
import org.thema.common.swing.LoggingDialog;
import org.thema.common.swing.PreferencesDialog;
import org.thema.data.IOImage;
import org.thema.data.feature.DefaultFeature;
import org.thema.data.feature.Feature;
import org.thema.data.IOFeature;
import org.thema.drawshape.image.CoverageShape;
import org.thema.drawshape.image.RasterShape;
import org.thema.drawshape.layer.DefaultGroupLayer;
import org.thema.drawshape.layer.FeatureLayer;
import org.thema.drawshape.layer.Layer;
import org.thema.drawshape.layer.LayerListener;
import org.thema.drawshape.layer.RasterLayer;
import org.thema.drawshape.style.CircleStyle;
import org.thema.drawshape.style.FeatureStyle;
import org.thema.drawshape.style.PointStyle;
import org.thema.drawshape.style.RasterStyle;
import org.thema.drawshape.style.table.ColorRamp;
import org.thema.drawshape.style.table.FeatureAttributeCollection;
import org.thema.drawshape.style.table.StrokeRamp;
import org.thema.drawshape.style.table.UniqueColorTable;
import org.thema.parallel.ExecutorService;
import org.thema.pixscape.lux.LuxDialog;
import org.thema.pixscape.lux.LuxTask;
import org.thema.pixscape.tools.Interpolate;
import org.thema.pixscape.tools.InterpolateDialog;

/**
 * The main frame and main entry point of PixScape.
 * 
 * @author Gilles Vuidel
 */
public class MainFrame extends javax.swing.JFrame {
    
    private Project project;
    private DefaultGroupLayer rootLayer;
    
    private ViewShedDialog viewshedDlg;
    private ViewTanDialog viewtanDlg;
    private SaturationDialog saturationDlg;
    
    private final LoggingDialog logFrame;
    
    /**
     * Creates new form MainFrame
     */
    public MainFrame() {
        setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/org/thema/pixscape/icone64.png"))); //NOI18N
        initComponents();
        setLocationRelativeTo(null);
        setTitle("PixScape - " + JavaLoader.getVersion(MainFrame.class)); //NOI18N
        mapViewer.putAddLayerButton();
        Config.setProgressBar(mapViewer.getProgressBar());
        logFrame = new LoggingDialog(this);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mapViewer = new org.thema.drawshape.ui.MapViewer();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        newProjectMenuItem = new javax.swing.JMenuItem();
        loadProjectMenuItem = new javax.swing.JMenuItem();
        prefMenuItem = new javax.swing.JMenuItem();
        logMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        dataMenu = new javax.swing.JMenu();
        loadDSMMenuItem = new javax.swing.JMenuItem();
        loadLandUseMenuItem = new javax.swing.JMenuItem();
        msMenu = new javax.swing.JMenu();
        genMSMenuItem = new javax.swing.JMenuItem();
        addScaleMenuItem = new javax.swing.JMenuItem();
        visMenu = new javax.swing.JMenu();
        viewShedMenuItem = new javax.swing.JMenuItem();
        viewTanMenuItem = new javax.swing.JMenuItem();
        saturationMenuItem = new javax.swing.JMenuItem();
        multiViewshedMenuItem = new javax.swing.JMenuItem();
        luxMenuItem = new javax.swing.JMenuItem();
        metricMenu = new javax.swing.JMenu();
        viewshedMetricMenuItem = new javax.swing.JMenuItem();
        tanMetricMenuItem = new javax.swing.JMenuItem();
        toolMenu = new javax.swing.JMenu();
        pathOrienMenuItem = new javax.swing.JMenuItem();
        interpGeomMenuItem = new javax.swing.JMenuItem();
        optionsMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
            public void windowDeactivated(java.awt.event.WindowEvent evt) {
                formWindowDeactivated(evt);
            }
        });

        mapViewer.setTreeLayerVisible(true);

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle"); // NOI18N
        fileMenu.setText(bundle.getString("MainFrame.fileMenu.text")); // NOI18N

        newProjectMenuItem.setText(bundle.getString("MainFrame.newProjectMenuItem.text")); // NOI18N
        newProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newProjectMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(newProjectMenuItem);

        loadProjectMenuItem.setText(bundle.getString("MainFrame.loadProjectMenuItem.text")); // NOI18N
        loadProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadProjectMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(loadProjectMenuItem);

        prefMenuItem.setText(bundle.getString("MainFrame.prefMenuItem.text")); // NOI18N
        prefMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prefMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(prefMenuItem);

        logMenuItem.setText(bundle.getString("MainFrame.logMenuItem.text")); // NOI18N
        logMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                logMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(logMenuItem);

        exitMenuItem.setText(bundle.getString("MainFrame.exitMenuItem.text")); // NOI18N
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        dataMenu.setText(bundle.getString("MainFrame.dataMenu.text")); // NOI18N

        loadDSMMenuItem.setText(bundle.getString("MainFrame.loadDSMMenuItem.text")); // NOI18N
        loadDSMMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadDSMMenuItemActionPerformed(evt);
            }
        });
        dataMenu.add(loadDSMMenuItem);

        loadLandUseMenuItem.setText(bundle.getString("MainFrame.loadLandUseMenuItem.text")); // NOI18N
        loadLandUseMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadLandUseMenuItemActionPerformed(evt);
            }
        });
        dataMenu.add(loadLandUseMenuItem);

        msMenu.setText(bundle.getString("MainFrame.msMenu.text")); // NOI18N

        genMSMenuItem.setText(bundle.getString("MainFrame.genMSMenuItem.text")); // NOI18N
        genMSMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                genMSMenuItemActionPerformed(evt);
            }
        });
        msMenu.add(genMSMenuItem);

        addScaleMenuItem.setText(bundle.getString("MainFrame.addScaleMenuItem.text")); // NOI18N
        addScaleMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addScaleMenuItemActionPerformed(evt);
            }
        });
        msMenu.add(addScaleMenuItem);

        dataMenu.add(msMenu);

        menuBar.add(dataMenu);

        visMenu.setText(bundle.getString("MainFrame.visMenu.text")); // NOI18N

        viewShedMenuItem.setText(bundle.getString("MainFrame.viewShedMenuItem.text")); // NOI18N
        viewShedMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewShedMenuItemActionPerformed(evt);
            }
        });
        visMenu.add(viewShedMenuItem);

        viewTanMenuItem.setText(bundle.getString("MainFrame.viewTanMenuItem.text")); // NOI18N
        viewTanMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewTanMenuItemActionPerformed(evt);
            }
        });
        visMenu.add(viewTanMenuItem);

        saturationMenuItem.setText(bundle.getString("MainFrame.saturationMenuItem.text")); // NOI18N
        saturationMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saturationMenuItemActionPerformed(evt);
            }
        });
        visMenu.add(saturationMenuItem);

        multiViewshedMenuItem.setText(bundle.getString("MainFrame.multiViewshedMenuItem.text")); // NOI18N
        multiViewshedMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                multiViewshedMenuItemActionPerformed(evt);
            }
        });
        visMenu.add(multiViewshedMenuItem);

        luxMenuItem.setText(bundle.getString("MainFrame.luxMenuItem.text")); // NOI18N
        luxMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                luxMenuItemActionPerformed(evt);
            }
        });
        visMenu.add(luxMenuItem);

        menuBar.add(visMenu);

        metricMenu.setText(bundle.getString("MainFrame.metricMenu.text")); // NOI18N

        viewshedMetricMenuItem.setText(bundle.getString("MainFrame.viewshedMetricMenuItem.text")); // NOI18N
        viewshedMetricMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewshedMetricMenuItemActionPerformed(evt);
            }
        });
        metricMenu.add(viewshedMetricMenuItem);

        tanMetricMenuItem.setText(bundle.getString("MainFrame.tanMetricMenuItem.text")); // NOI18N
        tanMetricMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tanMetricMenuItemActionPerformed(evt);
            }
        });
        metricMenu.add(tanMetricMenuItem);

        menuBar.add(metricMenu);

        toolMenu.setText(bundle.getString("MainFrame.toolMenu.text")); // NOI18N

        pathOrienMenuItem.setText(bundle.getString("MainFrame.pathOrienMenuItem.text")); // NOI18N
        pathOrienMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pathOrienMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(pathOrienMenuItem);

        interpGeomMenuItem.setText(bundle.getString("MainFrame.interpGeomMenuItem.text")); // NOI18N
        interpGeomMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                interpGeomMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(interpGeomMenuItem);

        optionsMenuItem.setText(bundle.getString("MainFrame.optionsMenuItem.text")); // NOI18N
        optionsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                optionsMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(optionsMenuItem);

        menuBar.add(toolMenu);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mapViewer, javax.swing.GroupLayout.DEFAULT_SIZE, 692, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mapViewer, javax.swing.GroupLayout.DEFAULT_SIZE, 469, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void loadProjectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadProjectMenuItemActionPerformed
        File file = Util.getFile(".xml", "Project file"); //NOI18N
        if(file == null) {
            return;
        }
        closeProject();
        try {
            project = Project.load(file);
            rootLayer = createLayers();
            mapViewer.setRootLayer(rootLayer);
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading project : " + ex.getLocalizedMessage()); 
        }
    }//GEN-LAST:event_loadProjectMenuItemActionPerformed

    private void viewShedMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewShedMenuItemActionPerformed
    	if(viewshedDlg == null) {
            viewshedDlg = new ViewShedDialog(this, project, mapViewer);
            
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            double screenWidth = screenSize.getWidth(); 
            int x = getX()+getWidth();
            int y = getY();
            //Vérification de la position de la fenêtre créée
            if(screenWidth < x + viewshedDlg.getWidth()) {
            	x = (int)(screenWidth-viewshedDlg.getWidth());
            }
            if(y < 0) {
            	y = 0;
            }
            viewshedDlg.setLocation(x, y);
        }
        viewshedDlg.setVisible(true);
        
    }//GEN-LAST:event_viewShedMenuItemActionPerformed

    private void loadLandUseMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadLandUseMenuItemActionPerformed
        File file = Util.getFile(".tif|.asc", "Raster"); //NOI18N
        if(file == null) {
            return;
        }
        try {
            GridCoverage2D cov = IOImage.loadCoverage(file);
            project.setLandUse(cov);
            rootLayer.addLayerFirst(getLandUseLayer(project.getDefaultScaleData()));
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error : " + ex.getLocalizedMessage());
        }
    }//GEN-LAST:event_loadLandUseMenuItemActionPerformed

    private void loadDSMMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadDSMMenuItemActionPerformed
        File file = Util.getFile(".tif|.asc", "Raster"); //NOI18N
        if(file == null) {
            return;
        }
        try {
            GridCoverage2D cov = IOImage.loadCoverage(file);
            project.setDSM(cov);
            rootLayer.addLayerFirst(new RasterLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("DSM"), new CoverageShape(cov, new RasterStyle(ColorRamp.RAMP_TEMP))));
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error : " + ex.getLocalizedMessage());
        }
    }//GEN-LAST:event_loadDSMMenuItemActionPerformed

    private void viewTanMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewTanMenuItemActionPerformed
        if(viewtanDlg == null) {
            viewtanDlg = new ViewTanDialog(this, project, mapViewer);
            
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            double screenWidth = screenSize.getWidth(); 
            int x = getX()+getWidth();
            int y = getY();
          //Vérification de la position de la fenêtre créée
            if(screenWidth < x + viewtanDlg.getWidth()) {
            	x = (int)(screenWidth-viewtanDlg.getWidth());
            }
            if(y < 0) {
            	y = 0;
            }
            viewtanDlg.setLocation(x, y);
        }
        viewtanDlg.setVisible(true);

    }//GEN-LAST:event_viewTanMenuItemActionPerformed

    private void prefMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prefMenuItemActionPerformed
        PreferencesDialog dlg = new PreferencesDialog(this, true);
        dlg.setProcPanelVisible(true);
        dlg.setVisible(true);
    }//GEN-LAST:event_prefMenuItemActionPerformed

    private void logMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_logMenuItemActionPerformed
        logFrame.setVisible(true);
    }//GEN-LAST:event_logMenuItemActionPerformed

    private void multiViewshedMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_multiViewshedMenuItemActionPerformed
        final MultiViewshedDialog dlg = new MultiViewshedDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                ProgressBar progressBar = Config.getProgressBar("Multi viewshed...");
                try {
                    List<Feature> points = (List)IOFeature.loadFeatures(dlg.pathFile, dlg.idField);
                    MultiViewshedTask task = new MultiViewshedTask(points, project, dlg.inverse, dlg.zDest, dlg.bounds, dlg.vectorOutput, dlg.outValue, progressBar);
                    ExecutorService.execute(task);
                    progressBar.setNote("Saving...");
                    String name = "multiviewshed-" + dlg.pathFile.getName().substring(0, dlg.pathFile.getName().lastIndexOf("."));
                    task.saveResult(project.getDirectory(), name);
                    Layer l;
                    if(dlg.vectorOutput) {
                        l = new FeatureLayer("Multi viewshed - " + name, (List)task.getResult(), new FeatureStyle(new Color(0, 0, 255, 20), null), project.getCRS());        
                    } else {
                        ColorRamp colorRamp = new ColorRamp(ColorRamp.RAMP_GRAY);
                        if(dlg.outValue == MultiViewshedTask.RasterValue.AREA) {
                            colorRamp.setScale(ColorRamp.SCALE_LOG);
                        }
                        l = new RasterLayer("Multi viewshed - " + name, new RasterShape((Raster)task.getResult(), 
                                project.getDefaultScaleData().getGridGeometry().getEnvelope2D(), new RasterStyle(colorRamp), true), project.getCRS());
                    }
                    l.setRemovable(true);
                    rootLayer.addLayerFirst(l);
                    l = new FeatureLayer("Points", points, new PointStyle());
                    l.setRemovable(true);
                    rootLayer.addLayerFirst(l);
                } catch (IOException ex) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(MainFrame.this, "An error has occured : " + ex);
                } finally {
                    progressBar.close();
                }
            }
        }).start();
        
    }//GEN-LAST:event_multiViewshedMenuItemActionPerformed

    private void newProjectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newProjectMenuItemActionPerformed
        NewProjectDialog dlg = new NewProjectDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        closeProject();
        
        try {
            GridCoverage2D dtm = IOImage.loadCoverage(dlg.dtm);
            project = new Project(dlg.name, dlg.path, dtm, dlg.resZ);
            rootLayer = createLayers();
            mapViewer.setRootLayer(rootLayer);
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(MainFrame.this, "An error has occured while creating project : " + ex);
        }
    }//GEN-LAST:event_newProjectMenuItemActionPerformed

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        closeProject();
        logFrame.dispose();
    }//GEN-LAST:event_formWindowClosed

    private void genMSMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_genMSMenuItemActionPerformed
        double r = project.getDefaultScaleData().getResolution();
        
        String res = JOptionPane.showInputDialog(this, java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("CREATE MULTI SCALE DATABASE"), 
                (int)(r*3) + ", " + (int)(r*9) + ", " + (int)(r*27) + ", " + (int)(r*81)); //NOI18N
        if(res == null || res.isEmpty()) {
            return;
        }
        NavigableSet<Double> resolutions = new TreeSet<>();
        for(String s : res.split(",")) { //NOI18N
            if(!s.trim().isEmpty()) {
                resolutions.add(Double.parseDouble(s.trim()));
            }
        }
        resolutions = resolutions.tailSet(r, false);
        if(resolutions.isEmpty()) {
            return;
        }
        
        try {
            project.removeMultiScaleData();
            
            RenderedImage dtm = project.getDefaultScaleData().getDtm();
            RenderedImage dsm = project.getDefaultScaleData().getDsm();
            RenderedImage land = project.getDefaultScaleData().getLand();
            for(Double resol : resolutions) {
                int scale = (int)(resol/r);
                RenderedImage dtmSamp = samplingDEM(dtm, scale);
                Envelope2D env = project.getDtmCov().getEnvelope2D();
                env = new Envelope2D(env.getCoordinateReferenceSystem(), 
                        env.x, env.y-r*(dtmSamp.getHeight()*scale-dtm.getHeight()), dtmSamp.getWidth() * scale*r, dtmSamp.getHeight() * scale*r);
                GridCoverage2D dtmCov = new GridCoverageFactory().create("", dtmSamp, env); //NOI18N
                ScaleData dataScale = new ScaleData(dtmCov, 
                        land != null ? samplingLanduse(land, scale) : null, 
                        dsm != null ? samplingDEM(dsm, scale) : null, 
                        1);
                project.addScaleData(dataScale);
            }
            
            rootLayer = createLayers();
            mapViewer.setRootLayer(rootLayer);
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }//GEN-LAST:event_genMSMenuItemActionPerformed

    private void viewshedMetricMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewshedMetricMenuItemActionPerformed
        final ViewMetricDialog dlg = new ViewMetricDialog(this, false, project.getCodes());
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        
        new Thread(new Runnable() {
            @Override
            public void run() {
                ProgressBar progressBar = Config.getProgressBar(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("METRICS..."));
                if(dlg.gridSampling) {
                    GridMetricTask task = new GridMetricTask(project, project.getStartZ(), dlg.zDest, 
                            dlg.inverse, dlg.bounds, dlg.selCodes, (List)dlg.metrics, dlg.sample, null, progressBar);
                    ExecutorService.execute(task);
                    Map<String, WritableRaster> result = task.getResult();
                    DefaultGroupLayer gl = new DefaultGroupLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("METRIC GRID RESULT"), true);
                    gl.setRemovable(true);
                    for(String name : result.keySet()) {
                        RasterStyle s = new RasterStyle();
                        s.setNoDataValue(-1);
                        RasterLayer l = new RasterLayer(name,
                                new RasterShape(result.get(name), project.getDtmCov().getEnvelope2D(), s, true), project.getCRS());
                        l.setRemovable(true);
                        gl.addLayerLast(l);
                    }
                    gl.setLayersVisible(false);
                    gl.getLayerFirst().setVisible(true);
                    rootLayer.addLayerFirst(gl);
                } else {
                    PointMetricTask task = new PointMetricTask(project, project.getStartZ(), dlg.zDest, 
                            dlg.inverse, dlg.bounds, (List)dlg.metrics, dlg.pointFile, dlg.idField, null, progressBar);
                    ExecutorService.execute(task);
                    List<DefaultFeature> features = task.getResult();
                    
                    String attr = dlg.metrics.get(0).getResultNames()[0];
                    FeatureAttributeCollection<Double> attrColl = new FeatureAttributeCollection(features, attr);
                    CircleStyle style = new CircleStyle(attr, Collections.min(attrColl), Collections.max(attrColl), new Color(0, 0, 0, 0), Color.black);
                    style.setRampStroke(new StrokeRamp(2, 2));
                    FeatureLayer l = new FeatureLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("METRIC POINT RESULT"), features, style);
                    l.setRemovable(true);
                    rootLayer.addLayerFirst(l);
                }

                progressBar.close();
            }
        }).start();
        
    }//GEN-LAST:event_viewshedMetricMenuItemActionPerformed

    private void optionsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_optionsMenuItemActionPerformed
        new OptionDialog(this, project).setVisible(true);
    }//GEN-LAST:event_optionsMenuItemActionPerformed

    private void tanMetricMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tanMetricMenuItemActionPerformed
        final ViewMetricDialog dlg = new ViewMetricDialog(this, true, project.getCodes());
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        
        new Thread(new Runnable() {
            @Override
            public void run() {
                ProgressBar progressBar = Config.getProgressBar(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("METRICS..."));
                if(dlg.gridSampling) {
                    GridMetricTask task = new GridMetricTask(project, project.getStartZ(), dlg.bounds, 
                            dlg.selCodes, (List)dlg.metrics, dlg.sample, null, progressBar);
                    ExecutorService.execute(task);
                    Map<String, WritableRaster> result = task.getResult();
                    DefaultGroupLayer gl = new DefaultGroupLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("METRIC GRID RESULT"), true);
                    gl.setRemovable(true);
                    for(String name : result.keySet()) {
                        RasterStyle s = new RasterStyle();
                        s.setNoDataValue(-1);
                        RasterLayer l = new RasterLayer(name,
                                new RasterShape(result.get(name), project.getDtmCov().getEnvelope2D(), s, true), project.getCRS());
                        l.setRemovable(true);
                        gl.addLayerLast(l);
                    }
                    gl.setLayersVisible(false);
                    gl.getLayerFirst().setVisible(true);
                    rootLayer.addLayerFirst(gl);
                } else {
                    PointMetricTask task = new PointMetricTask(project, project.getStartZ(), 
                            dlg.bounds, (List)dlg.metrics, dlg.pointFile, dlg.idField, null, progressBar);
                    ExecutorService.execute(task);
                    List<DefaultFeature> features = task.getResult();
                    
                    String attr = dlg.metrics.get(0).getResultNames()[0];
                    FeatureAttributeCollection<Double> attrColl = new FeatureAttributeCollection(features, attr);
                    CircleStyle style = new CircleStyle(attr, Collections.min(attrColl), Collections.max(attrColl), new Color(0, 0, 0, 0), Color.black);
                    style.setRampStroke(new StrokeRamp(2, 2));
                    FeatureLayer l = new FeatureLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("METRIC POINT RESULT"), features, style);
                    l.setRemovable(true);
                    rootLayer.addLayerFirst(l);
                }

                progressBar.close();
            }
        }).start();
    }//GEN-LAST:event_tanMetricMenuItemActionPerformed

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitMenuItemActionPerformed

    private void addScaleMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addScaleMenuItemActionPerformed
        AddScaleDialog dlg = new AddScaleDialog(this, project);
        dlg.setVisible(true);
        
        if(dlg.isOk) {
            rootLayer = createLayers();
            mapViewer.setRootLayer(rootLayer);
        }
    }//GEN-LAST:event_addScaleMenuItemActionPerformed

    private void pathOrienMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pathOrienMenuItemActionPerformed
        
        PointAttributeDialog dlg = new PointAttributeDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        try {
            List<DefaultFeature> points = IOFeature.loadFeatures(dlg.pathFile, dlg.idField);
            List<DefaultFeature> result = new ArrayList<>();
            if(dlg.setPathOrien) {
                for(int i = 0; i < points.size()-1; i++) {
                    Point p1 = points.get(i).getGeometry().getCentroid();
                    Point p2 = points.get(i+1).getGeometry().getCentroid();
                    double dir = Bounds.rad2deg(Math.atan2(p2.getY()-p1.getY(), p2.getX()-p1.getX()));
                    Bounds b = dlg.bounds.createBounds(dir);
                    result.add(b.createFeatureWithBoundAttr(points.get(i).getId(), points.get(i).getGeometry()));
                }
            } else {
                for(Feature p : points) {
                    result.add(dlg.bounds.createFeatureWithBoundAttr(p.getId(), p.getGeometry()));
                }
            }
            IOFeature.saveFeatures(result, new File(project.getDirectory(), dlg.outputName), IOFeature.getCRS(dlg.pathFile));
            FeatureLayer l = new FeatureLayer(dlg.outputName, result);
            l.setRemovable(true);
            rootLayer.addLayerFirst(l);
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
        
    }//GEN-LAST:event_pathOrienMenuItemActionPerformed

    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        if(viewshedDlg != null) {
            viewshedDlg.setAlwaysOnTop(true);
        }
        if(viewtanDlg != null) {
            viewtanDlg.setAlwaysOnTop(true);
        }
        logFrame.setAlwaysOnTop(true);
    }//GEN-LAST:event_formWindowActivated

    private void formWindowDeactivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowDeactivated
        if(viewshedDlg != null) {
            viewshedDlg.setAlwaysOnTop(false);
        }
        if(viewtanDlg != null) {
            viewtanDlg.setAlwaysOnTop(false);
        }
        logFrame.setAlwaysOnTop(false);
    }//GEN-LAST:event_formWindowDeactivated

    private void interpGeomMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_interpGeomMenuItemActionPerformed
        InterpolateDialog dlg = new InterpolateDialog(this, project.getDefaultScaleData());
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        try {
            List<? extends Feature> features = IOFeature.loadFeatures(dlg.pathFile);
            features = new Interpolate(project.getDefaultScaleData()).interpolate(features, dlg.ratio);
            IOFeature.saveFeatures(features, new File(dlg.pathFile.getParentFile(), dlg.outputName));
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_interpGeomMenuItemActionPerformed

    private void saturationMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saturationMenuItemActionPerformed
        if(saturationDlg == null) {
            saturationDlg = new SaturationDialog(this, project, mapViewer);
            
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            double screenWidth = screenSize.getWidth(); 
            int x = getX()+getWidth();
            int y = getY();
            //Vérification de la position de la fenêtre créée
            if(screenWidth < x + saturationDlg.getWidth()) {
            	x = (int)(screenWidth-saturationDlg.getWidth());
            }
            if(y < 0) {
            	y = 0;
            }
            saturationDlg.setLocation(x, y);
        }
        saturationDlg.setVisible(true);
    }//GEN-LAST:event_saturationMenuItemActionPerformed

    private void luxMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_luxMenuItemActionPerformed
        final LuxDialog dlg = new LuxDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        new Thread(new Runnable() {
            @Override
            public void run() {
                ProgressBar progressBar = Config.getProgressBar("Lux...");
                try {
                    List<Feature> points = (List)IOFeature.loadFeatures(dlg.pathFile);
                    LuxTask task = new LuxTask(points, project, dlg.zDest, dlg.bounds, progressBar);
                    ExecutorService.execute(task);
                    progressBar.setNote("Saving...");
                    String name = "lux-" + dlg.pathFile.getName().substring(0, dlg.pathFile.getName().lastIndexOf("."));
                    task.saveResult(project.getDirectory(), name);
                    Layer l;

                    ColorRamp colorRamp = new ColorRamp(ColorRamp.RAMP_GRAY);
                    colorRamp.setScale(ColorRamp.SCALE_LOG);
                    l = new RasterLayer("Lux - " + name, new RasterShape((Raster)task.getResult(), 
                            project.getDefaultScaleData().getGridGeometry().getEnvelope2D(), new RasterStyle(colorRamp), true), project.getCRS());
                    
                    l.setRemovable(true);
                    rootLayer.addLayerFirst(l);
                    l = new FeatureLayer("Points", points, new PointStyle());
                    l.setRemovable(true);
                    rootLayer.addLayerFirst(l);
                } catch (IOException ex) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(MainFrame.this, "An error has occured : " + ex);
                } finally {
                    progressBar.close();
                }
            }
        }).start();
    }//GEN-LAST:event_luxMenuItemActionPerformed

    private RenderedImage samplingDEM(RenderedImage dtm, int scale) {
        TiledImage img = new TiledImage(0, 0, 
                (int)Math.ceil(dtm.getWidth()/(double)scale), 
                (int)Math.ceil(dtm.getHeight()/(double)scale), 0, 0, 
                new BandedSampleModel(DataBuffer.TYPE_FLOAT, 1000, 1000, 1), 
                new ComponentColorModel(ColorSpace.getInstance(ColorSpace.CS_GRAY), false, false, ColorModel.OPAQUE, DataBuffer.TYPE_FLOAT));
        double [] tab = new double[scale*scale];
        for(int y = 0; y < img.getHeight(); y++) {
            for(int x = 0; x < img.getWidth(); x++) {
                final int w = Math.min(scale, dtm.getWidth()-x*scale);
                final int h = Math.min(scale, dtm.getHeight()-y*scale);
                dtm.getData(new Rectangle(x*scale, y*scale, w, h)).getSamples(x*scale, y*scale, w, h , 0, tab);
                int nbNaN = scale*scale - w*h;
                SummaryStatistics stats = new SummaryStatistics();
                for(int i = 0; i < w*h; i++) {
                    final double v = tab[i];
                    if(Double.isNaN(v)) {
                        nbNaN++;
                    } else {
                        stats.addValue(v);
                    }
                }          
                if(nbNaN < stats.getN()) {
                    img.setSample(x, y, 0, stats.getMean());
                } else {
                    img.setSample(x, y, 0, Double.NaN);
                }
            }
        }
        return img;
    }
    
    private RenderedImage samplingLanduse(RenderedImage land, int scale) {
        TiledImage img = new TiledImage(0, 0, 
                (int)Math.ceil(land.getWidth()/(double)scale), 
                (int)Math.ceil(land.getHeight()/(double)scale), 0, 0, 
                new BandedSampleModel(DataBuffer.TYPE_BYTE, 1000, 1000, 1), 
                new ComponentColorModel(ColorSpace.getInstance(ColorSpace.CS_GRAY), false, false, ColorModel.OPAQUE, DataBuffer.TYPE_BYTE));
        int [] tab = new int[scale*scale];
        for(int y = 0; y < img.getHeight(); y++) {
            for(int x = 0; x < img.getWidth(); x++) {
                int w = Math.min(scale, land.getWidth()-x*scale);
                int h = Math.min(scale, land.getHeight()-y*scale);
                land.getData(new Rectangle(x*scale, y*scale, w, h)).getSamples(x*scale, y*scale, w, h , 0, tab);
                int [] nb = new int[256];
                for(int i = 0; i < w*h; i++) {
                    nb[tab[i]]++;
                }     
                int max = Integer.MIN_VALUE;
                int landMax = -1;
                for(int i = 0; i < nb.length; i++) {
                    if(nb[i] > max) {
                        max = nb[i];
                        landMax = i;
                    }
                }
                img.setSample(x, y, 0, landMax);
            }
        }
        return img;
    }

    private void closeProject() {
        if(project != null) {
            project.close();
        }
        mapViewer.setRootLayer(new DefaultGroupLayer("")); //NOI18N
        project = null;
        viewshedDlg = null;
        viewtanDlg = null;
    }
    
    private DefaultGroupLayer createLayers() {
        DefaultGroupLayer layers = createScaleDataLayers(project.getDefaultScaleData());
        layers.setName(project.getName());
        layers.setExpanded(true);
        boolean scaleShow = project.getDefaultScaleData().isViewable();
        layers.getLayerFirst().setVisible(scaleShow);
        
        if(project.hasMultiScale()) {
            DefaultGroupLayer gl = new DefaultGroupLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("OTHER SCALES"), false);
            for(ScaleData data : project.getScaleDatas()) {
                if(data == project.getDefaultScaleData()) {
                    continue;
                }
                gl.addLayerLast(createScaleDataLayers(data));
                if(!scaleShow && data.isViewable()) {
                    gl.getLayerLast().setVisible(true);
                    scaleShow = true;
                }
            }
            layers.addLayerLast(gl);
        }
        
        return layers;
    } 

    private DefaultGroupLayer createScaleDataLayers(final ScaleData data) {
        DefaultGroupLayer gl = new DefaultGroupLayer(""+data.getResolution(), false) { //NOI18N

            @Override
            public JPopupMenu getContextMenu() {
                if(data == project.getDefaultScaleData()) {
                    return null;
                }
                JPopupMenu menu = new JPopupMenu();
                menu.add(new AbstractAction(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("REMOVE...")) {
                    @Override
                    public void actionPerformed(ActionEvent e) {
                        int res = JOptionPane.showConfirmDialog(null, java.text.MessageFormat.format(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("DO YOU WANT TO REMOVE THE SCALE {0} ?"), new Object[] {getName()}),
                        java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("REMOVE..."), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                        if(res == JOptionPane.YES_OPTION) {
                            try {
                                project.removeScaleData(Double.parseDouble(getName()));
                                getParent().removeLayer(getParent().getLayer(getName()));
                            } catch (IOException ex) {
                                throw new RuntimeException(ex);
                            }
                        }
                    }
                });
                return menu;
            }
            
        };
        
        gl.addLayerFirst(new RasterLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("DTM"), new CoverageShape(data.getDtmCov(), new RasterStyle(ColorRamp.RAMP_DEM))));
        if(data.getDsm() != null) {
            gl.addLayerFirst(new RasterLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("DSM"), new RasterShape(data.getDsm(), data.getDtmCov().getEnvelope2D(), 
                    new RasterStyle(ColorRamp.RAMP_TEMP))));
        }
        if(project.hasLandUse()) {
            gl.addLayerFirst(getLandUseLayer(data));
        }
        gl.setLayersVisible(false);
        return gl;
    } 
    
    private RasterLayer getLandUseLayer(ScaleData data) {
        final UniqueColorTable colorTable = new UniqueColorTable((Map)project.getLandColors());
        RasterLayer l = new RasterLayer(java.util.ResourceBundle.getBundle("org/thema/pixscape/Bundle").getString("LAND USE"), 
                new RasterShape(data.getLand(), data.getDtmCov().getEnvelope2D(), 
                new RasterStyle(colorTable, false)));
        l.addLayerListener(new LayerListener() {
            @Override
            public void layerVisibilityChanged(EventObject e) {                    
            }
            @Override
            public void layerStyleChanged(EventObject e) {
                for(Double code : project.getLandColors().keySet()) {
                    if(colorTable.getColorMapping().containsKey(code)) {
                        project.getLandColors().put(code, colorTable.getColor(code));
                    }
                }
            }
        });
        
        return l;
    }
    
    /**
     * Main program entry point.
     * Starts MPI, CLI or UI mode
     * @param args the command line arguments
     * @throws Exception
     */
    public static void main(String args[]) throws Exception {
        
        // MPI Execution
        if(args.length > 0 && args[0].equals("-mpi")) { //NOI18N
            new MpiLauncher(Arrays.copyOfRange(args, 1, args.length)).run();
            return;
        }
        
        Config.setNodeClass(MainFrame.class);
        PreferencesDialog.initLanguage();
            
        // CLI execution
        if(args.length > 0 && !args[0].equals(JavaLoader.NOFORK)) {        
            if(!GraphicsEnvironment.isHeadless() && SplashScreen.getSplashScreen() != null) {
                SplashScreen.getSplashScreen().close();
            }
            new CLITools().execute(args);
        } else { // UI execution
            JavaLoader.launchGUI(MainFrame.class, args.length == 0, 2048);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem addScaleMenuItem;
    private javax.swing.JMenu dataMenu;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem genMSMenuItem;
    private javax.swing.JMenuItem interpGeomMenuItem;
    private javax.swing.JMenuItem loadDSMMenuItem;
    private javax.swing.JMenuItem loadLandUseMenuItem;
    private javax.swing.JMenuItem loadProjectMenuItem;
    private javax.swing.JMenuItem logMenuItem;
    private javax.swing.JMenuItem luxMenuItem;
    private org.thema.drawshape.ui.MapViewer mapViewer;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenu metricMenu;
    private javax.swing.JMenu msMenu;
    private javax.swing.JMenuItem multiViewshedMenuItem;
    private javax.swing.JMenuItem newProjectMenuItem;
    private javax.swing.JMenuItem optionsMenuItem;
    private javax.swing.JMenuItem pathOrienMenuItem;
    private javax.swing.JMenuItem prefMenuItem;
    private javax.swing.JMenuItem saturationMenuItem;
    private javax.swing.JMenuItem tanMetricMenuItem;
    private javax.swing.JMenu toolMenu;
    private javax.swing.JMenuItem viewShedMenuItem;
    private javax.swing.JMenuItem viewTanMenuItem;
    private javax.swing.JMenuItem viewshedMetricMenuItem;
    private javax.swing.JMenu visMenu;
    // End of variables declaration//GEN-END:variables
}
